package oracle;

import java.math.BigInteger;
import java.util.Locale;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.FetchType;
import javax.persistence.Lob;
import javax.persistence.MappedSuperclass;
import javax.persistence.Transient;

import org.apache.commons.lang.SerializationUtils;
import org.hibernate.annotations.Formula;

import antlr.StringUtils;

@MappedSuperclass
public abstract class SuperclassEntity
{
	private static final long serialVersionUID = -3499613975334707262L;


	@Column(name = "UFLAGS", nullable = false, columnDefinition = "NUMBER(10)")
	private BigInteger uFlag;

	@Lob
	@Basic(fetch = FetchType.LAZY)
	@Column(name = "MYCLOB", nullable = true, columnDefinition = "CLOB")
	private String myClob;

	@Formula("TO_CHAR(OTHERSTRING)")
	private String otherString;


	/**
	 * constructor
	 */
	public SuperclassEntity()
	{
	}


	protected void setUFlag(final BigInteger uFlag)
	{
		if(uFlag == null)
		{
			throw new IllegalArgumentException("uebersFlag kann nicht auf null gesetzt werden!");
		}
		if((this.uFlag != null && this.uFlag.equals(uFlag)) || (this.uFlag == null && uFlag == null))
		{
			return;
		}
		this.uFlag = uFlag;
	}


	public BigInteger getUFlag()
	{
		return this.uFlag;
	}


	protected void setMyClob(final String myClob)
	{
		if((this.myClob != null && this.myClob.equals(myClob)) || (this.myClob == null && myClob == null))
		{
			return;
		}
		this.myClob = myClob;
	}


	protected String getMyClob()
	{
		return this.myClob;
	}
}
